package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/consume/md"
	"encoding/json"
	"testing"
	"time"
)

func TestSendMessageToUserVirtualCoinFlowAggregationConsume(t *testing.T) {
	dbcfg := cfg.DBCfg{
		Host:         "119.23.182.117:3306",
		Name:         "egg",
		User:         "root",
		Psw:          "Fnuo123com@",
		ShowLog:      true,
		MaxLifetime:  30,
		MaxOpenConns: 100,
		MaxIdleConns: 100,
		Path:         "tmp/%s.log",
	}
	db.InitDB(&dbcfg)
	data := md.CanalUserVirtualCoinFlowAggregation{
		Id:           "1",
		Uid:          "19",
		CoinId:       "1",
		Direction:    "1",
		Title:        "兑换到个人蛋蛋能量",
		Amount:       "20",
		BeforeAmount: "0",
		AfterAmount:  "80",
		SysFee:       "0",
		TransferType: "6",
	}

	message := md.CanalUserVirtualCoinFlowAggregationMessage[md.CanalUserVirtualCoinFlowAggregation]{
		Data:     []md.CanalUserVirtualCoinFlowAggregation{data},
		Database: "test_db",
		ES:       time.Now().UnixNano(),
		ID:       1,
		IsDdl:    false,
		Old:      nil,
		PkNames:  []string{"id"},
		Table:    "user_virtual_coin_flow",
		TS:       time.Now().Unix(),
		Type:     "INSERT",
	}

	m, _ := json.Marshal(message)
	err := handleEggCanalUserVirtualCoinFlowAggregationConsume(m)
	if err != nil {
		return
	}

}
