package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	utils2 "applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/implement"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func EggEnergyNewUserRegisterDataConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>EggEnergyNewUserRegisterDataConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleEggEnergyNewUserRegisterDataConsume(res.Body)
			if err != nil {
				fmt.Println("EggEnergyNewUserRegisterDataConsume_ERR:::::", err.Error())
				utils2.FilePutContents("EggEnergyNewUserRegisterDataConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
}

func handleEggEnergyNewUserRegisterDataConsume(msgData []byte) error {
	time.Sleep(time.Duration(100) * time.Millisecond) //休眠100毫秒
	// 1.解析mq中queue的数据结构体
	var msg *md2.EggNewUserRegisterData
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}

	// 2.为新注册的用户新增蛋蛋分记录
	err = egg_energy.ExistOrDefaultUserEggScore(msg.Uid)
	if err != nil {
		return err
	}

	// 3. 更新新增人数
	now := time.Now().Format("2006-01-02")
	growDataDb := implement.NewPlatformGrowDataDb(db.Db)
	growData, err := growDataDb.PlatformGrowDataGetOneByParams(map[string]interface{}{
		"key":   "date",
		"value": now,
	})
	if err != nil {
		return err
	}
	if growData != nil {
		growData.UserGrowCount++
		_, err = growDataDb.PlatformGrowDataUpdate(growData, "user_grow_count")
		if err != nil {
			return err
		}
	} else {
		m := model.PlatformGrowData{
			UserGrowCount: 1,
			Date:          now,
		}
		_, err = growDataDb.PlatformGrowDataInsert(&m)
		if err != nil {
			return err
		}
	}

	return nil
}
